class View(QGraphicsView):
  def __init__(self, parent=None):
    super(View, self).__init__(parent)
    self.setAcceptDrops(True)

    self.setDragMode(QGraphicsView.RubberBandDrag)
    self.setRenderHint(QPainter.Antialiasing)
    self.setRenderHint(QPainter.TextAntialiasing)

  def wheelEvent(self, event):
    factor = 1.41 ** (-event.delta() / 240.0)
    self.scale(factor, factor)

  def dragMoveEvent(self, event):
    if event.mimeData().hasFormat("application/x-graphicsItem"):
      event.setDropAction(Qt.MoveAction)
      event.accept()
    else:
      event.ignore()

  def dragEnterEvent(self, event):
    event.accept()

  def dropEvent(self, event):
    if event.mimeData().hasFormat("application/x-graphicsItem"):
      data = event.mimeData().data("application/x-graphicsItem")
      self.item = item.Item(event.pos(), self.scene)
      event.setDropAction(Qt.CopyAction)
      event.accept()
      self.updateGeometry()
      self.update()
    else:
      event.ignore()
